package com.ichaoj.ams.script;

import cn.hutool.http.ContentType;
import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpResponse;
import cn.hutool.http.HttpUtil;
import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONObject;
import com.ichaoj.ams.script.annotation.Script;
import com.ichaoj.ams.script.model.AirdropParam;
import com.ichaoj.ams.script.model.AirdropWallet;
import com.ichaoj.ams.script.model.SResult;
import lombok.extern.slf4j.Slf4j;

import java.util.HashMap;
import java.util.Map;

/**
 * @author wrenj
 */
@Slf4j
public class JsScript implements IScript {

    @Override
    public SResult run(Map<String, AirdropParam> params, AirdropWallet airdropWallet) {
        String nodeUrl = "http://127.0.0.1:13245";
        Map<String, Object> map = new HashMap<>(2);
        Map<String, Object> paramsMap = new HashMap<>(10);
        map.put("params", paramsMap);
        map.put("wallet", airdropWallet);
        params.forEach((key, value) -> paramsMap.put(key, value.getValue()));
        Class<? extends JsScript> clazz = this.getClass();
        Script script = clazz.getAnnotation(Script.class);
        HttpRequest post = HttpUtil.createPost(nodeUrl + "/" + script.name());
        post.body(JSON.toJSONString(map));
        post.contentType(ContentType.JSON.getValue());
        try (HttpResponse execute = post.execute()) {
            String body = execute.body();
            JSONObject resObj = JSON.parseObject(body);
            if (resObj.getInteger("code") == 0) {
                return resObj.getObject("data", SResult.class);
            } else {
                throw new RuntimeException(resObj.getString("msg"));
            }
        }
    }
}
