package com.ichaoj.ams.script.zksync2.swap.mute;

import java.math.BigInteger;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.concurrent.Callable;
import org.web3j.abi.TypeReference;
import org.web3j.abi.datatypes.Address;
import org.web3j.abi.datatypes.Bool;
import org.web3j.abi.datatypes.DynamicArray;
import org.web3j.abi.datatypes.Function;
import org.web3j.abi.datatypes.Type;
import org.web3j.abi.datatypes.generated.Uint256;
import org.web3j.crypto.Credentials;
import org.web3j.protocol.Web3j;
import org.web3j.protocol.core.RemoteFunctionCall;
import org.web3j.protocol.core.methods.response.TransactionReceipt;
import org.web3j.tuples.generated.Tuple2;
import org.web3j.tuples.generated.Tuple3;
import org.web3j.tuples.generated.Tuple6;
import org.web3j.tx.Contract;
import org.web3j.tx.TransactionManager;
import org.web3j.tx.gas.ContractGasProvider;

/**
 * <p>Auto generated code.
 * <p><strong>Do not modify!</strong>
 * <p>Please use the <a href="https://docs.web3j.io/command_line.html">web3j command line tools</a>,
 * or the org.web3j.codegen.SolidityFunctionWrapperGenerator in the
 * <a href="https://github.com/web3j/web3j/tree/master/codegen">codegen module</a> to update.
 *
 * <p>Generated with web3j version 1.4.2.
 */
@SuppressWarnings("rawtypes")
public class MuteSwap extends Contract {
    public static final String BINARY = "Bin file was not provided";

    public static final String FUNC_WETH = "WETH";

    public static final String FUNC_ADDLIQUIDITY = "addLiquidity";

    public static final String FUNC_ADDLIQUIDITYETH = "addLiquidityETH";

    public static final String FUNC_FACTORY = "factory";

    public static final String FUNC_GETAMOUNTOUT = "getAmountOut";

    public static final String FUNC_GETAMOUNTSOUT = "getAmountsOut";

    public static final String FUNC_GETAMOUNTSOUTEXPANDED = "getAmountsOutExpanded";

    public static final String FUNC_GETPAIRINFO = "getPairInfo";

    public static final String FUNC_GETRESERVES = "getReserves";

    public static final String FUNC_PAIRFOR = "pairFor";

    public static final String FUNC_QUOTE = "quote";

    public static final String FUNC_REMOVELIQUIDITY = "removeLiquidity";

    public static final String FUNC_REMOVELIQUIDITYETH = "removeLiquidityETH";

    public static final String FUNC_REMOVELIQUIDITYETHSUPPORTINGFEEONTRANSFERTOKENS = "removeLiquidityETHSupportingFeeOnTransferTokens";

    public static final String FUNC_SORTTOKENS = "sortTokens";

    public static final String FUNC_SWAPEXACTETHFORTOKENS = "swapExactETHForTokens";

    public static final String FUNC_SWAPEXACTETHFORTOKENSSUPPORTINGFEEONTRANSFERTOKENS = "swapExactETHForTokensSupportingFeeOnTransferTokens";

    public static final String FUNC_SWAPEXACTTOKENSFORETH = "swapExactTokensForETH";

    public static final String FUNC_SWAPEXACTTOKENSFORETHSUPPORTINGFEEONTRANSFERTOKENS = "swapExactTokensForETHSupportingFeeOnTransferTokens";

    public static final String FUNC_SWAPEXACTTOKENSFORTOKENS = "swapExactTokensForTokens";

    public static final String FUNC_SWAPEXACTTOKENSFORTOKENSSUPPORTINGFEEONTRANSFERTOKENS = "swapExactTokensForTokensSupportingFeeOnTransferTokens";

    @Deprecated
    protected MuteSwap(String contractAddress, Web3j web3j, Credentials credentials, BigInteger gasPrice, BigInteger gasLimit) {
        super(BINARY, contractAddress, web3j, credentials, gasPrice, gasLimit);
    }

    protected MuteSwap(String contractAddress, Web3j web3j, Credentials credentials, ContractGasProvider contractGasProvider) {
        super(BINARY, contractAddress, web3j, credentials, contractGasProvider);
    }

    @Deprecated
    protected MuteSwap(String contractAddress, Web3j web3j, TransactionManager transactionManager, BigInteger gasPrice, BigInteger gasLimit) {
        super(BINARY, contractAddress, web3j, transactionManager, gasPrice, gasLimit);
    }

    protected MuteSwap(String contractAddress, Web3j web3j, TransactionManager transactionManager, ContractGasProvider contractGasProvider) {
        super(BINARY, contractAddress, web3j, transactionManager, contractGasProvider);
    }

    public RemoteFunctionCall<String> WETH() {
        final Function function = new Function(FUNC_WETH,
                Arrays.<Type>asList(),
                Arrays.<TypeReference<?>>asList(new TypeReference<Address>() {}));
        return executeRemoteCallSingleValueReturn(function, String.class);
    }

    public RemoteFunctionCall<TransactionReceipt> addLiquidity(String tokenA, String tokenB, BigInteger amountADesired, BigInteger amountBDesired, BigInteger amountAMin, BigInteger amountBMin, String to, BigInteger deadline, BigInteger feeType, Boolean stable) {
        final Function function = new Function(
                FUNC_ADDLIQUIDITY,
                Arrays.<Type>asList(new org.web3j.abi.datatypes.Address(160, tokenA),
                        new org.web3j.abi.datatypes.Address(160, tokenB),
                        new org.web3j.abi.datatypes.generated.Uint256(amountADesired),
                        new org.web3j.abi.datatypes.generated.Uint256(amountBDesired),
                        new org.web3j.abi.datatypes.generated.Uint256(amountAMin),
                        new org.web3j.abi.datatypes.generated.Uint256(amountBMin),
                        new org.web3j.abi.datatypes.Address(160, to),
                        new org.web3j.abi.datatypes.generated.Uint256(deadline),
                        new org.web3j.abi.datatypes.generated.Uint256(feeType),
                        new org.web3j.abi.datatypes.Bool(stable)),
                Collections.<TypeReference<?>>emptyList());
        return executeRemoteCallTransaction(function);
    }

    public RemoteFunctionCall<TransactionReceipt> addLiquidityETH(String token, BigInteger amountTokenDesired, BigInteger amountTokenMin, BigInteger amountETHMin, String to, BigInteger deadline, BigInteger feeType, Boolean stable, BigInteger weiValue) {
        final Function function = new Function(
                FUNC_ADDLIQUIDITYETH,
                Arrays.<Type>asList(new org.web3j.abi.datatypes.Address(160, token),
                        new org.web3j.abi.datatypes.generated.Uint256(amountTokenDesired),
                        new org.web3j.abi.datatypes.generated.Uint256(amountTokenMin),
                        new org.web3j.abi.datatypes.generated.Uint256(amountETHMin),
                        new org.web3j.abi.datatypes.Address(160, to),
                        new org.web3j.abi.datatypes.generated.Uint256(deadline),
                        new org.web3j.abi.datatypes.generated.Uint256(feeType),
                        new org.web3j.abi.datatypes.Bool(stable)),
                Collections.<TypeReference<?>>emptyList());
        return executeRemoteCallTransaction(function, weiValue);
    }

    public RemoteFunctionCall<String> factory() {
        final Function function = new Function(FUNC_FACTORY,
                Arrays.<Type>asList(),
                Arrays.<TypeReference<?>>asList(new TypeReference<Address>() {}));
        return executeRemoteCallSingleValueReturn(function, String.class);
    }

    public RemoteFunctionCall<Tuple3<BigInteger, Boolean, BigInteger>> getAmountOut(BigInteger amountIn, String tokenIn, String tokenOut) {
        final Function function = new Function(FUNC_GETAMOUNTOUT,
                Arrays.<Type>asList(new org.web3j.abi.datatypes.generated.Uint256(amountIn),
                        new org.web3j.abi.datatypes.Address(160, tokenIn),
                        new org.web3j.abi.datatypes.Address(160, tokenOut)),
                Arrays.<TypeReference<?>>asList(new TypeReference<Uint256>() {}, new TypeReference<Bool>() {}, new TypeReference<Uint256>() {}));
        return new RemoteFunctionCall<Tuple3<BigInteger, Boolean, BigInteger>>(function,
                new Callable<Tuple3<BigInteger, Boolean, BigInteger>>() {
                    @Override
                    public Tuple3<BigInteger, Boolean, BigInteger> call() throws Exception {
                        List<Type> results = executeCallMultipleValueReturn(function);
                        return new Tuple3<BigInteger, Boolean, BigInteger>(
                                (BigInteger) results.get(0).getValue(),
                                (Boolean) results.get(1).getValue(),
                                (BigInteger) results.get(2).getValue());
                    }
                });
    }

    public RemoteFunctionCall<List> getAmountsOut(BigInteger amountIn, List<String> path, List<Boolean> stable) {
        final Function function = new Function(FUNC_GETAMOUNTSOUT,
                Arrays.<Type>asList(new org.web3j.abi.datatypes.generated.Uint256(amountIn),
                        new org.web3j.abi.datatypes.DynamicArray<org.web3j.abi.datatypes.Address>(
                                org.web3j.abi.datatypes.Address.class,
                                org.web3j.abi.Utils.typeMap(path, org.web3j.abi.datatypes.Address.class)),
                        new org.web3j.abi.datatypes.DynamicArray<org.web3j.abi.datatypes.Bool>(
                                org.web3j.abi.datatypes.Bool.class,
                                org.web3j.abi.Utils.typeMap(stable, org.web3j.abi.datatypes.Bool.class))),
                Arrays.<TypeReference<?>>asList(new TypeReference<DynamicArray<Uint256>>() {}));
        return new RemoteFunctionCall<List>(function,
                new Callable<List>() {
                    @Override
                    @SuppressWarnings("unchecked")
                    public List call() throws Exception {
                        List<Type> result = (List<Type>) executeCallSingleValueReturn(function, List.class);
                        return convertToNative(result);
                    }
                });
    }

    public RemoteFunctionCall<Tuple3<List<BigInteger>, List<Boolean>, List<BigInteger>>> getAmountsOutExpanded(BigInteger amountIn, List<String> path) {
        final Function function = new Function(FUNC_GETAMOUNTSOUTEXPANDED,
                Arrays.<Type>asList(new org.web3j.abi.datatypes.generated.Uint256(amountIn),
                        new org.web3j.abi.datatypes.DynamicArray<org.web3j.abi.datatypes.Address>(
                                org.web3j.abi.datatypes.Address.class,
                                org.web3j.abi.Utils.typeMap(path, org.web3j.abi.datatypes.Address.class))),
                Arrays.<TypeReference<?>>asList(new TypeReference<DynamicArray<Uint256>>() {}, new TypeReference<DynamicArray<Bool>>() {}, new TypeReference<DynamicArray<Uint256>>() {}));
        return new RemoteFunctionCall<Tuple3<List<BigInteger>, List<Boolean>, List<BigInteger>>>(function,
                new Callable<Tuple3<List<BigInteger>, List<Boolean>, List<BigInteger>>>() {
                    @Override
                    public Tuple3<List<BigInteger>, List<Boolean>, List<BigInteger>> call() throws Exception {
                        List<Type> results = executeCallMultipleValueReturn(function);
                        return new Tuple3<List<BigInteger>, List<Boolean>, List<BigInteger>>(
                                convertToNative((List<Uint256>) results.get(0).getValue()),
                                convertToNative((List<Bool>) results.get(1).getValue()),
                                convertToNative((List<Uint256>) results.get(2).getValue()));
                    }
                });
    }

    public RemoteFunctionCall<Tuple6<String, String, String, BigInteger, BigInteger, BigInteger>> getPairInfo(List<String> path, Boolean stable) {
        final Function function = new Function(FUNC_GETPAIRINFO,
                Arrays.<Type>asList(new org.web3j.abi.datatypes.DynamicArray<org.web3j.abi.datatypes.Address>(
                                org.web3j.abi.datatypes.Address.class,
                                org.web3j.abi.Utils.typeMap(path, org.web3j.abi.datatypes.Address.class)),
                        new org.web3j.abi.datatypes.Bool(stable)),
                Arrays.<TypeReference<?>>asList(new TypeReference<Address>() {}, new TypeReference<Address>() {}, new TypeReference<Address>() {}, new TypeReference<Uint256>() {}, new TypeReference<Uint256>() {}, new TypeReference<Uint256>() {}));
        return new RemoteFunctionCall<Tuple6<String, String, String, BigInteger, BigInteger, BigInteger>>(function,
                new Callable<Tuple6<String, String, String, BigInteger, BigInteger, BigInteger>>() {
                    @Override
                    public Tuple6<String, String, String, BigInteger, BigInteger, BigInteger> call() throws Exception {
                        List<Type> results = executeCallMultipleValueReturn(function);
                        return new Tuple6<String, String, String, BigInteger, BigInteger, BigInteger>(
                                (String) results.get(0).getValue(),
                                (String) results.get(1).getValue(),
                                (String) results.get(2).getValue(),
                                (BigInteger) results.get(3).getValue(),
                                (BigInteger) results.get(4).getValue(),
                                (BigInteger) results.get(5).getValue());
                    }
                });
    }

    public RemoteFunctionCall<Tuple2<BigInteger, BigInteger>> getReserves(String tokenA, String tokenB, Boolean stable) {
        final Function function = new Function(FUNC_GETRESERVES,
                Arrays.<Type>asList(new org.web3j.abi.datatypes.Address(160, tokenA),
                        new org.web3j.abi.datatypes.Address(160, tokenB),
                        new org.web3j.abi.datatypes.Bool(stable)),
                Arrays.<TypeReference<?>>asList(new TypeReference<Uint256>() {}, new TypeReference<Uint256>() {}));
        return new RemoteFunctionCall<Tuple2<BigInteger, BigInteger>>(function,
                new Callable<Tuple2<BigInteger, BigInteger>>() {
                    @Override
                    public Tuple2<BigInteger, BigInteger> call() throws Exception {
                        List<Type> results = executeCallMultipleValueReturn(function);
                        return new Tuple2<BigInteger, BigInteger>(
                                (BigInteger) results.get(0).getValue(),
                                (BigInteger) results.get(1).getValue());
                    }
                });
    }

    public RemoteFunctionCall<String> pairFor(String tokenA, String tokenB, Boolean stable) {
        final Function function = new Function(FUNC_PAIRFOR,
                Arrays.<Type>asList(new org.web3j.abi.datatypes.Address(160, tokenA),
                        new org.web3j.abi.datatypes.Address(160, tokenB),
                        new org.web3j.abi.datatypes.Bool(stable)),
                Arrays.<TypeReference<?>>asList(new TypeReference<Address>() {}));
        return executeRemoteCallSingleValueReturn(function, String.class);
    }

    public RemoteFunctionCall<BigInteger> quote(BigInteger amountA, BigInteger reserveA, BigInteger reserveB) {
        final Function function = new Function(FUNC_QUOTE,
                Arrays.<Type>asList(new org.web3j.abi.datatypes.generated.Uint256(amountA),
                        new org.web3j.abi.datatypes.generated.Uint256(reserveA),
                        new org.web3j.abi.datatypes.generated.Uint256(reserveB)),
                Arrays.<TypeReference<?>>asList(new TypeReference<Uint256>() {}));
        return executeRemoteCallSingleValueReturn(function, BigInteger.class);
    }

    public RemoteFunctionCall<TransactionReceipt> removeLiquidity(String tokenA, String tokenB, BigInteger liquidity, BigInteger amountAMin, BigInteger amountBMin, String to, BigInteger deadline, Boolean stable) {
        final Function function = new Function(
                FUNC_REMOVELIQUIDITY,
                Arrays.<Type>asList(new org.web3j.abi.datatypes.Address(160, tokenA),
                        new org.web3j.abi.datatypes.Address(160, tokenB),
                        new org.web3j.abi.datatypes.generated.Uint256(liquidity),
                        new org.web3j.abi.datatypes.generated.Uint256(amountAMin),
                        new org.web3j.abi.datatypes.generated.Uint256(amountBMin),
                        new org.web3j.abi.datatypes.Address(160, to),
                        new org.web3j.abi.datatypes.generated.Uint256(deadline),
                        new org.web3j.abi.datatypes.Bool(stable)),
                Collections.<TypeReference<?>>emptyList());
        return executeRemoteCallTransaction(function);
    }

    public RemoteFunctionCall<TransactionReceipt> removeLiquidityETH(String token, BigInteger liquidity, BigInteger amountTokenMin, BigInteger amountETHMin, String to, BigInteger deadline, Boolean stable) {
        final Function function = new Function(
                FUNC_REMOVELIQUIDITYETH,
                Arrays.<Type>asList(new org.web3j.abi.datatypes.Address(160, token),
                        new org.web3j.abi.datatypes.generated.Uint256(liquidity),
                        new org.web3j.abi.datatypes.generated.Uint256(amountTokenMin),
                        new org.web3j.abi.datatypes.generated.Uint256(amountETHMin),
                        new org.web3j.abi.datatypes.Address(160, to),
                        new org.web3j.abi.datatypes.generated.Uint256(deadline),
                        new org.web3j.abi.datatypes.Bool(stable)),
                Collections.<TypeReference<?>>emptyList());
        return executeRemoteCallTransaction(function);
    }

    public RemoteFunctionCall<TransactionReceipt> removeLiquidityETHSupportingFeeOnTransferTokens(String token, BigInteger liquidity, BigInteger amountTokenMin, BigInteger amountETHMin, String to, BigInteger deadline, Boolean stable) {
        final Function function = new Function(
                FUNC_REMOVELIQUIDITYETHSUPPORTINGFEEONTRANSFERTOKENS,
                Arrays.<Type>asList(new org.web3j.abi.datatypes.Address(160, token),
                        new org.web3j.abi.datatypes.generated.Uint256(liquidity),
                        new org.web3j.abi.datatypes.generated.Uint256(amountTokenMin),
                        new org.web3j.abi.datatypes.generated.Uint256(amountETHMin),
                        new org.web3j.abi.datatypes.Address(160, to),
                        new org.web3j.abi.datatypes.generated.Uint256(deadline),
                        new org.web3j.abi.datatypes.Bool(stable)),
                Collections.<TypeReference<?>>emptyList());
        return executeRemoteCallTransaction(function);
    }

    public RemoteFunctionCall<Tuple2<String, String>> sortTokens(String tokenA, String tokenB) {
        final Function function = new Function(FUNC_SORTTOKENS,
                Arrays.<Type>asList(new org.web3j.abi.datatypes.Address(160, tokenA),
                        new org.web3j.abi.datatypes.Address(160, tokenB)),
                Arrays.<TypeReference<?>>asList(new TypeReference<Address>() {}, new TypeReference<Address>() {}));
        return new RemoteFunctionCall<Tuple2<String, String>>(function,
                new Callable<Tuple2<String, String>>() {
                    @Override
                    public Tuple2<String, String> call() throws Exception {
                        List<Type> results = executeCallMultipleValueReturn(function);
                        return new Tuple2<String, String>(
                                (String) results.get(0).getValue(),
                                (String) results.get(1).getValue());
                    }
                });
    }

    public RemoteFunctionCall<TransactionReceipt> swapExactETHForTokens(BigInteger amountOutMin, List<String> path, String to, BigInteger deadline, List<Boolean> stable, BigInteger weiValue) {
        final Function function = new Function(
                FUNC_SWAPEXACTETHFORTOKENS,
                Arrays.<Type>asList(new org.web3j.abi.datatypes.generated.Uint256(amountOutMin),
                        new org.web3j.abi.datatypes.DynamicArray<org.web3j.abi.datatypes.Address>(
                                org.web3j.abi.datatypes.Address.class,
                                org.web3j.abi.Utils.typeMap(path, org.web3j.abi.datatypes.Address.class)),
                        new org.web3j.abi.datatypes.Address(160, to),
                        new org.web3j.abi.datatypes.generated.Uint256(deadline),
                        new org.web3j.abi.datatypes.DynamicArray<org.web3j.abi.datatypes.Bool>(
                                org.web3j.abi.datatypes.Bool.class,
                                org.web3j.abi.Utils.typeMap(stable, org.web3j.abi.datatypes.Bool.class))),
                Collections.<TypeReference<?>>emptyList());
        return executeRemoteCallTransaction(function, weiValue);
    }

    public RemoteFunctionCall<TransactionReceipt> swapExactETHForTokensSupportingFeeOnTransferTokens(BigInteger amountOutMin, List<String> path, String to, BigInteger deadline, List<Boolean> stable, BigInteger weiValue) {
        final Function function = new Function(
                FUNC_SWAPEXACTETHFORTOKENSSUPPORTINGFEEONTRANSFERTOKENS,
                Arrays.<Type>asList(new org.web3j.abi.datatypes.generated.Uint256(amountOutMin),
                        new org.web3j.abi.datatypes.DynamicArray<org.web3j.abi.datatypes.Address>(
                                org.web3j.abi.datatypes.Address.class,
                                org.web3j.abi.Utils.typeMap(path, org.web3j.abi.datatypes.Address.class)),
                        new org.web3j.abi.datatypes.Address(160, to),
                        new org.web3j.abi.datatypes.generated.Uint256(deadline),
                        new org.web3j.abi.datatypes.DynamicArray<org.web3j.abi.datatypes.Bool>(
                                org.web3j.abi.datatypes.Bool.class,
                                org.web3j.abi.Utils.typeMap(stable, org.web3j.abi.datatypes.Bool.class))),
                Collections.<TypeReference<?>>emptyList());
        return executeRemoteCallTransaction(function, weiValue);
    }

    public RemoteFunctionCall<TransactionReceipt> swapExactTokensForETH(BigInteger amountIn, BigInteger amountOutMin, List<String> path, String to, BigInteger deadline, List<Boolean> stable) {
        final Function function = new Function(
                FUNC_SWAPEXACTTOKENSFORETH,
                Arrays.<Type>asList(new org.web3j.abi.datatypes.generated.Uint256(amountIn),
                        new org.web3j.abi.datatypes.generated.Uint256(amountOutMin),
                        new org.web3j.abi.datatypes.DynamicArray<org.web3j.abi.datatypes.Address>(
                                org.web3j.abi.datatypes.Address.class,
                                org.web3j.abi.Utils.typeMap(path, org.web3j.abi.datatypes.Address.class)),
                        new org.web3j.abi.datatypes.Address(160, to),
                        new org.web3j.abi.datatypes.generated.Uint256(deadline),
                        new org.web3j.abi.datatypes.DynamicArray<org.web3j.abi.datatypes.Bool>(
                                org.web3j.abi.datatypes.Bool.class,
                                org.web3j.abi.Utils.typeMap(stable, org.web3j.abi.datatypes.Bool.class))),
                Collections.<TypeReference<?>>emptyList());
        return executeRemoteCallTransaction(function);
    }

    public RemoteFunctionCall<TransactionReceipt> swapExactTokensForETHSupportingFeeOnTransferTokens(BigInteger amountIn, BigInteger amountOutMin, List<String> path, String to, BigInteger deadline, List<Boolean> stable) {
        final Function function = new Function(
                FUNC_SWAPEXACTTOKENSFORETHSUPPORTINGFEEONTRANSFERTOKENS,
                Arrays.<Type>asList(new org.web3j.abi.datatypes.generated.Uint256(amountIn),
                        new org.web3j.abi.datatypes.generated.Uint256(amountOutMin),
                        new org.web3j.abi.datatypes.DynamicArray<org.web3j.abi.datatypes.Address>(
                                org.web3j.abi.datatypes.Address.class,
                                org.web3j.abi.Utils.typeMap(path, org.web3j.abi.datatypes.Address.class)),
                        new org.web3j.abi.datatypes.Address(160, to),
                        new org.web3j.abi.datatypes.generated.Uint256(deadline),
                        new org.web3j.abi.datatypes.DynamicArray<org.web3j.abi.datatypes.Bool>(
                                org.web3j.abi.datatypes.Bool.class,
                                org.web3j.abi.Utils.typeMap(stable, org.web3j.abi.datatypes.Bool.class))),
                Collections.<TypeReference<?>>emptyList());
        return executeRemoteCallTransaction(function);
    }

    public RemoteFunctionCall<TransactionReceipt> swapExactTokensForTokens(BigInteger amountIn, BigInteger amountOutMin, List<String> path, String to, BigInteger deadline, List<Boolean> stable) {
        final Function function = new Function(
                FUNC_SWAPEXACTTOKENSFORTOKENS,
                Arrays.<Type>asList(new org.web3j.abi.datatypes.generated.Uint256(amountIn),
                        new org.web3j.abi.datatypes.generated.Uint256(amountOutMin),
                        new org.web3j.abi.datatypes.DynamicArray<org.web3j.abi.datatypes.Address>(
                                org.web3j.abi.datatypes.Address.class,
                                org.web3j.abi.Utils.typeMap(path, org.web3j.abi.datatypes.Address.class)),
                        new org.web3j.abi.datatypes.Address(160, to),
                        new org.web3j.abi.datatypes.generated.Uint256(deadline),
                        new org.web3j.abi.datatypes.DynamicArray<org.web3j.abi.datatypes.Bool>(
                                org.web3j.abi.datatypes.Bool.class,
                                org.web3j.abi.Utils.typeMap(stable, org.web3j.abi.datatypes.Bool.class))),
                Collections.<TypeReference<?>>emptyList());
        return executeRemoteCallTransaction(function);
    }

    public RemoteFunctionCall<TransactionReceipt> swapExactTokensForTokensSupportingFeeOnTransferTokens(BigInteger amountIn, BigInteger amountOutMin, List<String> path, String to, BigInteger deadline, List<Boolean> stable) {
        final Function function = new Function(
                FUNC_SWAPEXACTTOKENSFORTOKENSSUPPORTINGFEEONTRANSFERTOKENS,
                Arrays.<Type>asList(new org.web3j.abi.datatypes.generated.Uint256(amountIn),
                        new org.web3j.abi.datatypes.generated.Uint256(amountOutMin),
                        new org.web3j.abi.datatypes.DynamicArray<org.web3j.abi.datatypes.Address>(
                                org.web3j.abi.datatypes.Address.class,
                                org.web3j.abi.Utils.typeMap(path, org.web3j.abi.datatypes.Address.class)),
                        new org.web3j.abi.datatypes.Address(160, to),
                        new org.web3j.abi.datatypes.generated.Uint256(deadline),
                        new org.web3j.abi.datatypes.DynamicArray<org.web3j.abi.datatypes.Bool>(
                                org.web3j.abi.datatypes.Bool.class,
                                org.web3j.abi.Utils.typeMap(stable, org.web3j.abi.datatypes.Bool.class))),
                Collections.<TypeReference<?>>emptyList());
        return executeRemoteCallTransaction(function);
    }

    @Deprecated
    public static MuteSwap load(String contractAddress, Web3j web3j, Credentials credentials, BigInteger gasPrice, BigInteger gasLimit) {
        return new MuteSwap(contractAddress, web3j, credentials, gasPrice, gasLimit);
    }

    @Deprecated
    public static MuteSwap load(String contractAddress, Web3j web3j, TransactionManager transactionManager, BigInteger gasPrice, BigInteger gasLimit) {
        return new MuteSwap(contractAddress, web3j, transactionManager, gasPrice, gasLimit);
    }

    public static MuteSwap load(String contractAddress, Web3j web3j, Credentials credentials, ContractGasProvider contractGasProvider) {
        return new MuteSwap(contractAddress, web3j, credentials, contractGasProvider);
    }

    public static MuteSwap load(String contractAddress, Web3j web3j, TransactionManager transactionManager, ContractGasProvider contractGasProvider) {
        return new MuteSwap(contractAddress, web3j, transactionManager, contractGasProvider);
    }
}
